--REZ A1, by ImortalTJones--

jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end


skinvars = GetSkinProperties()
trackWidth = 11.5 -- uses a wide water track even for vehicles
fullsteep = jumping or skinvars.prefersteep
if skinvars.colorcount < 3 then
	OverrideTrackColorForDynamicBlockColors({255,255,255})
	end

SetScene{
	glowpasses = 0,
	glowspread = 0,
	radialblur_strength = 1,
	dynamicFOV = false,
	FOV = 65,
--	radialblur_strength = fif(jumping,2.5,0),
	--environment = "city",
	water=false,
	watertint = {r=255,g=255,b=255,a=0},
	towropes = jumping,--use the tow ropes if jumping
	airdebris_count = ifhifi(2500,100),
	airdebris_density = ifhifi(60,2),
	airdebris_particlesize = fif(jumping, 0.3, 0.4),
	airdebris_fieldsize = 350,
	airdebris_layer = 18,
	--usedefaultrails=false,
	useblackgrid=true,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep, 1, .7)}, -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
	skywirecolor={r=90,g=150,b=255},
	fogenabled = true,
    fogcolor={60,30,0},
    fogstart=700, 
    fogend=1700,
	use_intro_swoop_cam = true,
	hide_default_background_verticals = true,
}
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = 1,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={255,255,255}
	}
	
SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematerial={
		texture = "grid3.png",
		color = {r=255,g=255,b=255},
		shader = fif(ispuzzle, "VertexColorUnlitTintedAlpha", "DiffuseVertexColored"),
			shadercolors={
				_Color = {255,255,255},
				},
	},
	puzzlematchmaterial={
		texture = "Matching2.png",
		shader = "Unlit/Transparent",
	},
	puzzleflyupmaterial={
		texture = "match.png",
		shader = "VertexColorUnlitTintedAddFlyup",

	}
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		--mesh="skyscraper42.obj",
		mesh="pyramidbuildings.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader="VertexColorUnlitTintedSkywire",
		renderqueue = 3000,
		shadercolors={
			_Color={150,150,150},
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="buildingtex.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}

if not jumping then
	SetBlocks{
	   allow_mod_block_scaling = false,
		colorblocks={
			mesh = "progressnode.obj",
			shader=fif(skinvars.colorcount < 3, "Unlit/Texture"),
		    shadercolors={
              _color = {255,255,255},
		},
			renderqueue = 2000,
			layer = 13,
			texture ="progressnodetex.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,1},
		},
		greyblocks={
			mesh = "Vmissle4.obj",
			shader ="RimLight",--"RimLight",
		    shadercolors={
			  _Color={215,215,215},
		},
			renderqueue = 2000,
			texture = "mistex4.png",
			float_on_water = false,
			scale = {1,1,1}
		}
	}
	

end

CreateRepeatedMeshRail{--floor red bars graphic
    ahead_renderdist = 1000,
    behind_renderdist = 50,
    spacing = 15, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="floorrails",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		--mesh="pingpong.obj",
		mesh="floorrails.obj",
		layer=13,
		shader="VertexColorUnlitTinted", --"VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255}, --{r=255,g=255,b=255}
		},
		texture="red.png"
	}
}
CreateRepeatedMeshRail{--side bars near player
    ahead_renderdist = 500,
    behind_renderdist = 30,
    spacing = 10, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "static", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="railing",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		--mesh="pingpong.obj",
		mesh="side bars.obj",
		layer=13,
		shader="VertexColorUnlitTinted", --"VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={r=255,g=255,b=255}
		},
		texture="sidebartex.png"
	}
}
CreateRepeatedMeshRail{--Roof grid graphic
    ahead_renderdist = 500,
    behind_renderdist = 70,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "highway", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="railing",
		shadowcaster = false,
		flatten=true,
		shadowreceiver = false,
		--mesh="pingpong.obj",
		mesh="gridtop.obj",
		layer=13,
		shader="Rim Light", --"VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={231,92,0},
			_RimColor={0,255,0},
		},
		shadersettings={
			_Threshold=11
		},
		texture="OR-red.jpg"
	}
}
CreateObject{ --Outside graphics top n bot
	gameobject={
		name="bot",
		pos={x=0,y=0,z=0},
		mesh="outside.obj",
		shader="Proximity2ColorAlpha", -- fade out the distant lines to remove the noise from being smaller than pixels at distance
				shadercolors={
			_Color = {colorsource={100,0,0}, scaletype="intensity", minscaler=2, maxscaler=2}
		},
		shadersettings={
			_StartDistance = 13000,
			_FullDistance = 25000
		},
		texture="red.png",
		scale = {x=1,y=1,z=1},
	}
}

--[[
CreateObject{--skywires, the red lines in the sky. A railed object is attached to the track and moves along it with the player.
	railoffset=0,
	floatonwaterwaves = false,
	colorMode = "static",
	gameobject={
		name="scriptSkyWires",
		pos={x=0,y=0,z=0},
		mesh="outside.obj",
		layer=ifhifi(13,13), -- in low detail the glow camera (layer 18) is disabled, so move the skywires to the main camera's layer (13)
		shader="RimLightHatchedSurferExternal",
		shadercolors={
			_Color={r=255,g=255,b=255},
		},
		texture="OR-red.jpg",
		scale = {x=1,y=1,z=1},
		lookat = "end"
	}
}
--]]
CreateRepeatedMeshRail{--side's of tack buildings
    ahead_renderdist = 1000,
    behind_renderdist = 200,
    spacing = 4, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2998,
		--mesh="pingpong.obj",
		mesh="side buildings3.obj",
		layer=13,
		shader="RimLightHatchedSurferExternal", --"VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}
	        _RimColor={20,20,20},	
		},
		texture="sidebuildtex3.png"
	}
}
CreateRepeatedMeshRail{--Side buildings foundation
    ahead_renderdist = 1100,
    behind_renderdist = 300,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2997,
		--mesh="pingpong.obj",
		mesh="side foundations.obj",
		layer=13,
		shader="RimLightHatchedSurferExternal", --"VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}
	        _RimColor={20,20,20},	
		},
		texture="ground1.png"
	}
}
CreateRepeatedMeshRail{--hex underfloor
    ahead_renderdist = 700,
    behind_renderdist = 100,
    spacing = 5, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="hex.obj",
		layer=13,
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}
	        _RimColor={255,255,255},	
		},
		texture="hextex.png"
	}
}
CreateRepeatedMeshRail{--hex guy l
    ahead_renderdist = 700,
    behind_renderdist = 200,
    spacing = 20, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="hex guy L",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="hexguyleft.obj",
		layer=13,
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}	
		},
		texture="hexguytex.png"
	}
}
CreateRepeatedMeshRail{--hex guy r
    ahead_renderdist = 700,
    behind_renderdist = 200,
    spacing = 20, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="hexguyright.obj",
		layer=13,
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}	
		},
		texture="hexguytex.png"
	}
}
CreateRepeatedMeshRail{--inside grid right
    ahead_renderdist = 700,
    behind_renderdist = 100,
    spacing = 50, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="insidegridleft.obj",
		layer=13,
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}
	        _RimColor={20,20,20},	
		},
		texture="OR-red.jpg"
	}
}
CreateRepeatedMeshRail{--inside grid left
    ahead_renderdist = 700,
    behind_renderdist = 100,
    spacing = 50, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="insidegridright.obj",
		layer=13,
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}
	        _RimColor={20,20,20},	
		},
		texture="OR-red.jpg"
	}
}
CreateRepeatedMeshRail{--hexholders
    ahead_renderdist = 700,
    behind_renderdist = 100,
    spacing = 10, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="hexholders.obj",
		layer=13,
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={255,255,255},			--{r=255,g=255,b=255}
	        _RimColor={20,20,20},	
		},
		texture="hexholdertex.png"
	}
}
CreateRepeatedMeshRail{--floor main
    ahead_renderdist = 750,
    behind_renderdist = 200,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "highway", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="main floor",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 2000,
		--mesh="pingpong.obj",
		mesh="floor2.obj",
		layer=13,
		shader="Rim Light",
		shadercolors={
			_Color="highway",			--{r=255,g=255,b=255}
	        _RimColor={0,0,0},	
		},
		texture="floortex3.png"
	}
}
CreateRepeatedMeshRail{--trans floor
    ahead_renderdist = 700,
    behind_renderdist = 40,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="sides",
		shadowcaster = false,
		shadowreceiver = false,
		flatten=true,
		renderqueue = 3000,
		--mesh="pingpong.obj",
		mesh="transfloor.obj",
		layer=13,
	   color = {r=150,g=150,b=150,a=150},
	   shader="VertexColorUnlitTintedAlpha2",
		texture="black.png"
	}
}
--[[
CreateRepeatedMeshRail{ --tester
    ahead_renderdist = 800,
    behind_renderdist = 70,
    spacing = 500, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="railing",
		shadowcaster = false,
		shadowreceiver = false,
		--mesh="pingpong.obj",
		mesh="test.obj",
		layer=18,
		shader="RimLightHatchedSurferExternal", --"VertexColorUnlitTintedSkywire",
	    colorMode="static",
	    color = {r=90,g=150,b=255},
		texture="white.png"
	}
}
--]]

SetRings{
	texture="ring5.png",
	shader="VertexColorUnlitTintedAddSmooth",
	layer = 13,
	size=19,
	percentringed=.17,
	airtexture="air.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=50
}

SetBlockFlashes{
	texture="hit.jpg",
}
--[[CreateObject{
	gameobject={
		name="gridob",
		pos={x=0,y=0,z=0},
		mesh="ringobject.obj",
		renderqueue=1000,
		layer=ifhifi(18,13),
		colormode="static",
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={r=90,g=150,b=255}
		},
		texture="ringtex.png",
		scale = {x=1.2,y=1.2,z=1.2},
	}
}
--]]
if jumping then
	SetBlocks{
		colorblocks={
			mesh = "progressnode.obj",
			shader=fif(skinvars.colorcount < 3, "Unlit/Texture"),
		    shadercolors={
			    _Color={r=255,g=255,b=255}
		},
			texture = "progressnodetex.png",
		    height = 0,
		    float_on_water = true,
		    scale = {.83,.83,.83},
		},
		greyblocks={
			mesh = "Vmissle4.obj",
			shader ="RimLight",--"RimLight",
		    shadercolors={
			  _Color={215,215,215},
		},
			renderqueue = 2000,
			texture = "mistex4.png",
			float_on_water = false,
			scale = {.05,.05,.05}
		}
	}
end

CreateObject{
	name="endportal",
	tracknode="end",
	gameobject={
	    scale = {x=25,y=25,z=25},
		mesh="earthgiga.obj",
		renderqueue=2000,
		flatten=false,
		layer=ifhifi(13,13),
		shader="RimLightHatchedSurferExternal",
		shadercolors={
			_Color={r=200,g=200,b=200}
		},
		texture="earthterratex.png"
	}
}

SetSkybox{
	skysphere = "bg.png"
}
--[[	
SetTrackColors{
    {r=90, g=150, b=255},
    {r=77, g=200, b=208},
	{r=90, g=150, b=255},
	{r=200, g=200, b=200},
	{r=162, g=82, b=189},
	{r=190, g=0, b=0},
	{r=255, g=156, b=0},
}
--]]
SetTrackColors{
    {r=255, g=255, b=255},
    {r=90, g=150, b=255},
	{r=108, g=255, b=255},
	{r=235, g=238, b=18},
	{r=255, g=127, b=53},
	{r=188, g=85, b=232},
	{r=200, g=35, b=35},
	{r=255, g=144, b=0},
}
SetBlockColors{
	{r=108, g=255, b=255}, --teal
	{r=235, g=238, b=18}, --yellow
	{r=20, g=0, b=255}, --blue
	{r=188, g=85, b=232}, --purple
	{r=255, g=35, b=35}, --red
	{r=255, g=96, b=0}, --or
}

track = GetTrack()--get the track data from the game engine
if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

--		if (i+40)%120==0 then
--			buildingNodesToo[#buildingNodesToo+1] = i
--			local xOffset = 150 + 1650*math.random()
--			if math.random() > 0.5 then xOffset = xOffset * -1 end
--			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
--		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=20,
                    		maxDistanceShown=1500,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}

--	BatchRenderEveryFrame{prefabName="BuildingCloneMeToo", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
--							locations=buildingNodesToo,
--                    		rotateWithTrack=false,
--                    		maxShown=50,
--                    		maxDistanceShown=2000,
--							offsets=offsetsToo,
--							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
--							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
--						}
end


if jumping then
	SetPlayer{
		--showsurfer = true,
		--showboard = true,
		cameramode = "first_jumpthird",
		--cameramode_air = "third",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={ --sets the camera position when in first person mode. Can change this while the game is running.
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 1,
			puzzleoffset=-0.3,
		},
		camthird={ --sets the two camera positions for 3rd person mode. lerps out towards pos2 when the song is less intense
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 0.75,
			pos2={0,2.8,-3.50475},
			rot2={20.49113,0,0},
			puzzleoffset=-0.3,
			puzzleoffset2=-0.3,
			strafefactorFar = 1},
		surfer={ --set all the models used to represent the surfer
		roostercolor = {255,127,53,10},
		water_rooster_z_offset = -1.45,
			arms={
				--mesh="arm.obj",
				shader="RimLightHatchedSurfer",
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2},
					_RimColor={0,63,192}
				},
				texture="FullLeftArm_1024_wAO.png"
			},
			--leg={
			--	mesh="foot.obj",
			--	shader="RimLightHatchedSurfer",
			--	shadercolors={
			--		_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=-1, paramMax=2},
			--		_RimColor={0,49,242}
			--		--_RimColor={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3}
			--	},
			--	texture="foot.png"
			--},
			board={
				mesh="b3.obj",
				shader=ifhifi("RimLight"), -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3999,
				shadercolors={ --each color in the shader can be set to a static color, or change every frame like the arm model above
					_Color={r=255,g=255,b=255},
					_RimColor="highway"
				},
				texture="b3.png",
				
			},
			body={
				--mesh="surferbot.obj",
				shader="RimLightHatchedSurferExternal", -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3000,
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=1.7
				},
				texture="robot_HighContrast.png"
			}
		}
	}
else
	SetPlayer{
		--showsurfer = false,
		--showboard = false,
		cameramode = "third",
	--	cameramode_air = "first",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,4.2,-3.2},
			rot={29,0,0},
			strafefactor = 0.75,
			strafefactorFar = .75,
			pos2={0,5,-4},
			rot2={29,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-1.6,
			puzzleoffset2=-1.6},
		vehicle={ --livecoding not supported here
			min_hover_height= 0.13,
			max_hover_height = 0.23, -- 0.75
			use_water_rooster = false,
			roostercolor = {255,127,53,255},
			water_rooster_z_offset = -2,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			layer = 15,
			mesh = "REZV4.obj",
			calculatenormals = true,
			renderqueue = 2000,
			shader="RimLightHatchedSurferExternal",
			shadercolors={
					_Color={r=255,g=255,b=255},
					_RimColor={0,255,0}
				},
			texture="REZV3.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{0.4,0.4,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1.5,1,1.5,1,1.5,.5},
						extrusions=24,
						stretch=-0.1291,
						updateseconds = 0.025,
						instances={
							{pos={0,0.65,-1.8},rot={0,0,58.713},scale={0.01,0.01,0.01}},
						}}
		}
	}
	--[[
	SetPlayer{
		cameramode = "third",

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0},
			strafefactor=1},
		camthird={
			pos={0,5,-4},
			rot={30,0,0},
			strafefactor=0.66,
			pos2={1,5,-4},
			rot2={30,0,0},
			strafefactorFar=.75,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
		vehicle={ --livecoding not supported here
			pos={x=0,y=0,z=0},
			mesh="vehicle1a.obj",
			shader="VertexColorUnlitTinted",
			shadercolors={
				_Color={r=1,g=1,b=1}},
				--_RimColor={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3}},
			texture="vehicle1a_ao.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.5,.5,0},{.5,.5,0},{.5,-.5,0},{-.5,-.5,0}},
						perShapeNodeColorScalers={1,1,0,0},
						extrusions=22,
						stretch=-0.1191,
						instances={
							{pos={0,.281,-1.33},rot={0,0,0},scale={1,1,1}},
							{pos={.1236,0.2,-1.297},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={-.1236,0.2,-1.297},rot={0,0,313.7366},scale={.7,.7,.7}}
						}}
			}
	}
	--]]
end

if jumping then wakeHeight=(ifhifi(2.5,2.5)) else wakeHeight = 0 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTintedAddSmooth",
		    shadercolors={_Color={r=0,g=0,b=0}},
	        shadersettings={_StartDistance=3.92, _FullDistance=11.9},
	layer = 13, -- looks better not rendered in background when water surface is not type 2
	bottomcolor = {r=255,g=127,b=53},
	topcolor ="Highway",
	extraspray = false
}


